variables:
  NITRILE_VERSION: "0.4.23"

image: cleanlang/ci:latest

build-linux-x64:
  rules:
    - if: $CI_COMMIT_TAG
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  interruptible: true
  before_script:
    - apt-get update -qq
    - apt-get install -y -qq build-essential gcc
    - nitrile update
    - nitrile fetch
  script:
    - nitrile build
    - nitrile test
    - nitrile package
  artifacts:
    paths:
      - text-*.tar.gz
      - properties.xml
    reports:
      junit: properties.xml

build-linux-x86:
  rules:
    - if: $CI_COMMIT_TAG
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  interruptible: true
  before_script:
    - dpkg --add-architecture i386
    - apt-get update -qq
    - apt-get install -y -qq build-essential gcc gcc-multilib libc6-i386
    - nitrile update
    - nitrile --arch=x86 fetch
  script:
    - nitrile --arch=x86 build
    - nitrile --arch=x86 test
    - nitrile --arch=x86 package
  artifacts:
    paths:
      - text-*.tar.gz
      - properties.xml
    reports:
      junit: properties.xml

build-windows-x64:
  rules:
    - if: $CI_COMMIT_TAG
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  interruptible: true
  tags: [saas-windows-medium-amd64]
  before_script:
    # We need to get the environment set by a batch script; see https://stackoverflow.com/a/41399983:
    - >-
      cmd /c '"C:\Program Files (x86)\Microsoft Visual Studio\2022\BuildTools\VC\Auxiliary\Build\vcvarsall.bat" amd64 & set'
      | select-string '^([^=]*)=(.*)$'
      | foreach-object { [Environment]::SetEnvironmentVariable($_.Matches[0].Groups[1].Value, $_.Matches[0].Groups[2].Value) }
    # Used in build step
    - choco install -y make awk curl
    # Install nitrile
    - Set-ExecutionPolicy ByPass -Scope Process -Force
    - $Env:NitrileVersion = $NITRILE_VERSION
    - (New-Object System.Net.WebClient).DownloadString('https://clean-lang.org/install.ps1') | powershell -Command -
    - $Env:PATH += ";${Env:APPDATA}\Nitrile\bin"
    - nitrile update
    - nitrile fetch
  script:
    - nitrile build
    - nitrile test
    - nitrile package
  artifacts:
    paths:
      - text-*.tar.gz
      - properties.xml
    reports:
      junit: properties.xml

publish:
  needs:
    - build-linux-x64
    - build-linux-x86
    - build-windows-x64
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - nitrile publish --targets=linux-x64,linux-x86,windows-x64
